// rsspecan_spurious_emissions_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsspecan_spurious_emissions_example.h"
#include "rsspecan_spurious_emissions_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define WINDOW        1


#define CHECKERR(fcal) if ((rsspecan_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsspecan_spurious_emissions_exampleDlg dialog




Crsspecan_spurious_emissions_exampleDlg::Crsspecan_spurious_emissions_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsspecan_spurious_emissions_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(FALSE)
	, m_CenterFreq(1000000000)
	, m_FreqSpan(100000000)
	, m_Timeout(15000)
	, m_Margin(0)
	, m_StartFreq(100000000)
	, m_StopFreq(102000000)
	, m_ResBand(10000)
	, m_VideoBand(30000)
	, m_Detector(4)
	, m_RefLevel(-30)
	, m_PeakNum(25)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsspecan_spurious_emissions_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_CENTERFREQ, m_CenterFreq);
	DDX_Text(pDX, IDC_FREQSPAN, m_FreqSpan);
	DDX_Text(pDX, IDC_TIMEOUT, m_Timeout);
	DDX_Text(pDX, IDC_MARGIN, m_Margin);
	DDV_MinMaxDouble(pDX, m_Margin, -200, 200);
	DDX_Text(pDX, IDC_STARTFREQ, m_StartFreq);
	DDX_Text(pDX, IDC_STOPFREQ, m_StopFreq);
	DDX_Text(pDX, IDC_RESBAND, m_ResBand);
	DDX_Text(pDX, IDC_VIDEOBAND, m_VideoBand);
	DDX_CBIndex(pDX, IDC_DETECTOR, m_Detector);
	DDX_Text(pDX, IDC_REFLEVEL, m_RefLevel);
	DDV_MinMaxDouble(pDX, m_RefLevel, -130, 30);
	DDX_Text(pDX, IDC_PEAK_NUM, m_PeakNum);
	DDV_MinMaxInt(pDX, m_PeakNum, 1, 50);
	DDX_Control(pDX, IDC_DATALIST, m_PeakList);
}

BEGIN_MESSAGE_MAP(Crsspecan_spurious_emissions_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsspecan_spurious_emissions_exampleDlg::OnBnClickedStart)
END_MESSAGE_MAP()


// Crsspecan_spurious_emissions_exampleDlg message handlers

BOOL Crsspecan_spurious_emissions_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Init Table Header
	m_PeakList.InsertColumn (0, _T("Frequency [Hz]"),LVCFMT_LEFT,135);
	m_PeakList.InsertColumn (1, _T("Level [dBm]"),LVCFMT_LEFT,135);
	m_PeakList.InsertColumn (2, _T("Delta Limit [dB]"),LVCFMT_LEFT,135);

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsspecan_spurious_emissions_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsspecan_spurious_emissions_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsspecan_spurious_emissions_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	LVITEM		t_item;
	CString text;
	long i;

	ViInt32 timeout = 15000;    /* default value */
	ViInt32 returnedValues;
    ViReal64 frequency[50];
	ViReal64 level[50];
	ViReal64 deltaLimit[50];
	CString		str;

	/* initialize driver */
	CHECKERR (rsspecan_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
	m_ResourceString.UnlockBuffer();

	/* switch device display on/off */
	CHECKERR( rsspecan_ConfigureDisplayUpdate(m_InstrSession,m_Display));

	/* Set instrument to single sweep mode - continous mode is done
     * programmatically because this is the only way how to
     * synchronize measurement using *OPC
     */
    CHECKERR (rsspecan_ConfigureSignalStatisticSweep(m_InstrSession, VI_FALSE));

	/* configure specan device: center frequency and span */
	CHECKERR (rsspecan_ConfigureFrequencyCenterSpan (m_InstrSession, WINDOW, m_CenterFreq, m_FreqSpan));

	/* switch on the spurious emissions measurement */
    CHECKERR (rsspecan_ConfigureSEState(m_InstrSession, VI_TRUE));

    /* configure the peak search for spurious emission measurement */
	CHECKERR (rsspecan_ConfigureSEPeakSearch(m_InstrSession, WINDOW, m_Margin, m_PeakNum));

    /* configure the start and stop frequency for the specified range */
    CHECKERR (rsspecan_ConfigureSESweepListStartStop(m_InstrSession, 1, m_StartFreq, m_StopFreq));

    /* configure the resolution and video bandwidth values for the specified range */
	CHECKERR (rsspecan_ConfigureSESweepListBandwidth(m_InstrSession, 1, m_ResBand, m_VideoBand));

    /* configure the detector value for the specified range */
    CHECKERR (rsspecan_ConfigureSESweepListDetector(m_InstrSession, 1, m_Detector));

    /* configure the reference level for the specified range */
    CHECKERR (rsspecan_ConfigureSESweepListReferenceLevel(m_InstrSession, 1, m_RefLevel));

    /* start a new spurious measurement */
    CHECKERR (rsspecan_InitiateSpurious(m_InstrSession, WINDOW, m_Timeout));

    /* search the peaks in spurious emissions data */
    CHECKERR (rsspecan_SESearchPeak(m_InstrSession));

    /* read the spurious emissions peak list */
	CHECKERR (rsspecan_ReadSEPeakList(m_InstrSession, m_PeakNum, frequency, level, deltaLimit, &returnedValues));

	m_PeakList.DeleteAllItems();

    /* write peak list to table */
	for (int i = 0; i < m_PeakNum; i++)
    {
		m_PeakList.InsertItem(i,_T(""));
		str.Format(_T("%.f"),frequency[i]);
        m_PeakList.SetItemText(i, 0, str);
		str.Format(_T("%.2f"),level[i]);
		m_PeakList.SetItemText(i, 1, str);
		str.Format(_T("%.f"),deltaLimit[i]);
		m_PeakList.SetItemText(i, 2, str);
    }

	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
	/* close session */
	CHECKERR (rsspecan_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsspecan_spurious_emissions_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsspecan_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsspecan_error_message(m_InstrSession, rsspecan_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsspecan_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsspecan_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsspecan_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}