// rsspecan_time_domain_power_measurement_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsspecan_time_domain_power_measurement_example.h"
#include "rsspecan_time_domain_power_measurement_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define WINDOW        1


#define CHECKERR(fcal) if ((rsspecan_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsspecan_time_domain_power_measurement_exampleDlg dialog




Crsspecan_time_domain_power_measurement_exampleDlg::Crsspecan_time_domain_power_measurement_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsspecan_time_domain_power_measurement_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	, m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(FALSE)
	, m_CenterFreq(1000000000)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsspecan_time_domain_power_measurement_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_CENTERFREQ, m_CenterFreq);
	DDX_Control(pDX, IDC_LIST1, m_Results);
}

BEGIN_MESSAGE_MAP(Crsspecan_time_domain_power_measurement_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsspecan_time_domain_power_measurement_exampleDlg::OnBnClickedStart)
END_MESSAGE_MAP()


// Crsspecan_time_domain_power_measurement_exampleDlg message handlers

BOOL Crsspecan_time_domain_power_measurement_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

		// Init Table Columns
	m_Results.InsertColumn (0, _T(""), LVCFMT_LEFT,140);
	m_Results.InsertColumn (1, _T(""), LVCFMT_LEFT,50);
	m_Results.InsertColumn (2, _T(""), LVCFMT_LEFT,40);

	//Insert first column items
	LVITEM		t_item;
	CString text;

	t_item.mask = LVIF_TEXT | LVIF_STATE;
	t_item.iSubItem = 0;
	t_item.stateMask = LVIS_SELECTED;
	t_item.state = 0;
	t_item.lParam = 0;

	t_item.iItem = 0;	
	text.Format (_T("Peak"));
	t_item.pszText = text.GetBuffer(0);
	m_Results.InsertItem(&t_item);
	t_item.iItem = 1;	
	text.Format (_T("RMS"));
	t_item.pszText = text.GetBuffer(0);
	m_Results.InsertItem(&t_item);
	t_item.iItem = 2;	
	text.Format (_T("Mean"));
	t_item.pszText = text.GetBuffer(0);
	m_Results.InsertItem(&t_item);
	t_item.iItem = 3;	
	text.Format (_T("Standard Deviation"));
	t_item.pszText = text.GetBuffer(0);
	m_Results.InsertItem(&t_item);

	//Update last column
	m_Results.SetItemText(0, 2, _T("dBm"));
	m_Results.SetItemText(1, 2, _T("dBm"));
	m_Results.SetItemText(2, 2, _T("dBm"));
	m_Results.SetItemText(3, 2, _T("dB"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsspecan_time_domain_power_measurement_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsspecan_time_domain_power_measurement_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsspecan_time_domain_power_measurement_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	ViInt32 timeout = 15000;    /* default value */
    ViReal64 resultPeak, resultRMS, resultMean, resultSDev;
	CString		str;

	/* initialize driver */
	CHECKERR (rsspecan_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
	m_ResourceString.UnlockBuffer();

	/* switch device display on/off */
	CHECKERR( rsspecan_ConfigureDisplayUpdate(m_InstrSession,m_Display));

	/* Set instrument to single sweep mode - continous mode is done
     * programmatically because this is the only way how to
     * synchronize measurement using *OPC
     */
    CHECKERR (rsspecan_ConfigureSignalStatisticSweep(m_InstrSession, VI_FALSE));

	/* configure specan device: center frequency and span */
	CHECKERR (rsspecan_ConfigureFrequencyCenterSpan (m_InstrSession, WINDOW, m_CenterFreq, 0));

	/* configure time domain power measurement parameters */
    CHECKERR (rsspecan_ConfigureTimeDomainPowerMeasurement(m_InstrSession, WINDOW, VI_TRUE, VI_TRUE, VI_TRUE, VI_TRUE, VI_FALSE, VI_FALSE, 0));

    /* switch on time domain power measurement */
    CHECKERR (rsspecan_ConfigureTimeDomainPowerMeasurementState(m_InstrSession, WINDOW, VI_TRUE));

    /* do a sweep */
    CHECKERR (rsspecan_Initiate(m_InstrSession, WINDOW, timeout));

    /* query peak power result */
    CHECKERR (rsspecan_QueryTDomPowerResult(m_InstrSession, WINDOW,0,0, &resultPeak));

    /* query RMS power result */
    CHECKERR (rsspecan_QueryTDomPowerResult(m_InstrSession, WINDOW,1,0, &resultRMS));

    /* query mean power result */
    CHECKERR (rsspecan_QueryTDomPowerResult(m_InstrSession, WINDOW,2,0, &resultMean));

    /* query SDEV power result */
    CHECKERR (rsspecan_QueryTDomPowerResult(m_InstrSession, WINDOW,3,0, &resultSDev));

    /* show channel power result in front panel textbox */
	str.Format(_T("%.2f"),resultPeak);
	m_Results.SetItemText(0, 1, str);
	str.Format(_T("%.2f"),resultRMS);
	m_Results.SetItemText(1, 1, str);
	str.Format(_T("%.2f"),resultMean);
	m_Results.SetItemText(2, 1, str);
	str.Format(_T("%.2f"),resultSDev);
	m_Results.SetItemText(3, 1, str);

	
	UpdateData(false);

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
	CHECKERR (rsspecan_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsspecan_time_domain_power_measurement_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsspecan_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsspecan_error_message(m_InstrSession, rsspecan_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsspecan_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsspecan_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsspecan_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}