// rsspecan_wait_for_calibration_end_exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rsspecan_wait_for_calibration_end_example.h"
#include "rsspecan_wait_for_calibration_end_exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define WINDOW        1
#define ARRAY_SIZE    50


#define CHECKERR(fcal) if ((rsspecan_status = fcal) < 0)\
					   {\
							cleanup(VI_FALSE);\
							return;\
					   }

// Crsspecan_wait_for_calibration_end_exampleDlg dialog




Crsspecan_wait_for_calibration_end_exampleDlg::Crsspecan_wait_for_calibration_end_exampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Crsspecan_wait_for_calibration_end_exampleDlg::IDD, pParent)
	, m_ResourceString(_T("GPIB::20::INSTR"))
	,  m_IDQuery(TRUE)
	, m_Reset(TRUE)
	, m_Display(FALSE)
	, m_CalEnd(TRUE)
	, m_STestEnd(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_RSICON);
}

void Crsspecan_wait_for_calibration_end_exampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_RESOURCE_STRING, m_ResourceString);
	DDX_Check(pDX, IDC_IDQUERY, m_IDQuery);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Check(pDX, IDC_CHECK1, m_CalEnd);
	DDX_Check(pDX, IDC_CHECK2, m_STestEnd);
	DDX_Check(pDX, IDC_DISPLAY, m_Display);
}

BEGIN_MESSAGE_MAP(Crsspecan_wait_for_calibration_end_exampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &Crsspecan_wait_for_calibration_end_exampleDlg::OnBnClickedStart)
END_MESSAGE_MAP()


// Crsspecan_wait_for_calibration_end_exampleDlg message handlers

BOOL Crsspecan_wait_for_calibration_end_exampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Crsspecan_wait_for_calibration_end_exampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Crsspecan_wait_for_calibration_end_exampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void Crsspecan_wait_for_calibration_end_exampleDlg::OnBnClickedStart()
{
	USES_CONVERSION;
	UpdateData ();
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	ViInt32 timeout = 50000;    /* default value */
	ViInt32 result32;
	ViInt16 result16;
	ViChar message[ARRAY_SIZE];
	CString messageString;

	/* initialize driver */
	CHECKERR (rsspecan_init ((char *) ((LPCTSTR) W2A(m_ResourceString.LockBuffer())), m_IDQuery, m_Reset, &m_InstrSession));
	m_ResourceString.UnlockBuffer();

	/* switch device display on/off */
	CHECKERR( rsspecan_ConfigureDisplayUpdate(m_InstrSession, m_Display));

	if (m_CalEnd)
    {
        /* Initiates the calibration and waits for its end */
        CHECKERR( rsspecan_Calibration(m_InstrSession, VI_TRUE, timeout, &result32));

        if (result32 == 0)
        {
            MessageBox(_T("Calibration successful"), _T("Calibration Result"), MB_OK);
        }
        else
        {
			MessageBox(_T("Calibration Error code: 0x%8X", result32), _T("Calibration Result"), MB_OK);
        }
    }

    if (m_STestEnd)
    {
        /* Initiates the self-test and waits for its end */
        CHECKERR( rsspecan_self_test(m_InstrSession, &result16, message));

        if (result16 == 0)
        {
			MessageBox(_T("Self Test Passed"), _T("Self Test Result"), MB_OK);
        }
        else
        {
            MessageBox(_T("%s\nSelf Test Error code: 0x%8X", messageString, result16), _T("Self Test Result"), MB_OK);
        }

    }

	cur = LoadCursor (NULL, IDC_ARROW);
	SetCursor (cur);
	
	CHECKERR (rsspecan_close (m_InstrSession));
}

/*===========================================================================*/
/* Function: Cleanup
/* Purpose:  Closes the VISA session to the instrument and in case of error
/*           queries the error and shows the dialog box with error message.
/*           In case Device Clear is requested, it is necessary to set the
/*           argument deviceClear to VI_TRUE.
/*===========================================================================*/
void Crsspecan_wait_for_calibration_end_exampleDlg::cleanup(ViBoolean deviceClear)
{
	if (rsspecan_status < 0)
	{
		ViChar      error_message[256];
		ViStatus    temp_status;
		CString		message;
		CString		error_string;
		
		/* Query the error message from the instrument driver. This
		 * function gets the error message for VISA and driver failures
		 */
		temp_status = rsspecan_error_message(m_InstrSession, rsspecan_status, error_message);
		
		if (temp_status == VI_WARN_UNKNOWN_STATUS)
		{
			/* Query the error message from the instrument. This
			 * function gets the error message directly from instrument, like
			 * execution error, out of range error etc.
			 */
			rsspecan_error_query(m_InstrSession, &temp_status, error_message);
		}
		error_string = error_message;
		message.Format (_T ("Error 0x%8X occured:\n\n%s"), rsspecan_status, error_string);
		AfxMessageBox (message, MB_OK | MB_ICONSTOP); 
	}
	
	/* Device Clear is a low-level command and should be used in case the
	 * instrument is waiting for Operation Complete to cancel the wait.
	 * It is useful for instance in case of incorrect external trigger
	 * when the instrument does not respond to any other command because of
	 * waiting for trigger.
	 */
	if (deviceClear)
	{
		viClear (m_InstrSession);
		viPrintf (m_InstrSession, "*CLS\n");
	}
	
	rsspecan_close (m_InstrSession);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor (cur);
}